Subject: Re: [RFC 1/2] sctp: convert hash list to RCU

From: Stephen Hemminger <[email-masked]>
Date: Fri, 19 Feb 2010 08:18:56 -0800

On Fri, 19 Feb 2010 07:58:25 -0800
"Paul E. McKenney" <[email-masked]> wrote:

> On Thu, Feb 18, 2010 at 09:55:21PM -0800, Stephen Hemminger wrote:
> > This patch converts existing SCTP hash list to using RCU
> > rather than reader/writer lock. Also, get rid of no longer used
> > locking wrappers.
> > 
> > In future, the SCTP hash locking should be broken out from the
> > hash structure because of the wasted space for the hash locks
> > and associated holes. A single lock per hashlist is sufficient
> > now that RCU is used.
> > 
> > Compile tested only. I can't think of an SCTP stress application.
> > 
> > P.s: Some janitor ought to go through and remove the locking
> > macros here.
> 
> One question below about what looks to be mixing of RCU and RCU-bh
> read-side critical sections while waiting only for RCU grace periods.
> Unless I am missing something, this can result in memory corruption.
> 

Thanks, I copied the original locking which was broken there as well.

--